package test;
import static org.junit.Assert.*;
import java.util.HashSet;
import java.util.Set;
import org.junit.Before;
import org.junit.Test;
import card.Card;
import card.CardFactory;
import card.Zako;
import player.CardCollection;
public class CardCollectionTest  {
	private CardCollection c;
	private static final String[] zako1name = {"Aka","Ao","Kuro"};
	private CardFactory factory1;
	@Before
	public void setUp() throws Exception {
		c = new CardCollection();
		factory1 = new CardFactory(0,zako1name,new Zako());
		for(Card card : factory1.getList()){
			c.add(card);
		}
	}
	@Test
	public void testToString() {
		CardCollection c = new CardCollection();
		Card[] card = factory1.getList().toArray(new Card[0]);
		c.add(card[0]);
		c.add(card[1]);
		c.add(card[1]);
		assertEquals("1 Aka(s) and 2 Ao(s)",c.toString());
	}
	@Test
	public void testContains(){
		for(Card card : factory1.getList()){
			assertTrue(c.contains(card));
		}
	}
	@Test
	public void testCompletes2(){
		Set<Integer> watch = new HashSet<Integer>();
		CardCollection c = new CardCollection();
		assertTrue(c.completes(watch));
		for(Card card : factory1.getList()){
			c.add(card);
			assertTrue(c.completes(watch));
		}
	}
	@Test
	public void testCompletes(){
		Set<Integer> watch = new HashSet<Integer>();
		watch.add(0);
		watch.add(1);
		watch.add(2);
		CardCollection c = new CardCollection();
		Card[] card = factory1.getList().toArray(new Card[0]);
		assertFalse(c.completes(watch));
		c.add(card[0]);
		assertFalse(c.completes(watch));
		c.add(card[1]);
		assertFalse(c.completes(watch));
		c.add(card[1]);
		assertFalse(c.completes(watch));
		c.add(card[2]);
		assertTrue(c.completes(watch));
	}
}
