package test;
import static org.junit.Assert.*;
import static org.hamcrest.CoreMatchers.*;
import java.util.List;
import card.Card;
public class CardTestScenario<E extends Card> {
	protected List<E> list;
	private Tester<E> tester;
	protected static interface Tester<E> {
		boolean check(E card);
	}
	public CardTestScenario(List<E> list1) {
		list = list1;
	}
	public void execCheck() {
		int i=0;
		for(E card: list){
			assertThat("index="+i, tester.check(card), is(true));
			i++;
		}	
	}
	public void setTest(Tester<E> tester) {
		this.tester = tester;
	}
	public void testCompareTo() {
		for(Card c1 : list){
			for(Card c2 :list){
				int result = c1.compareTo(c2);
				String message = c1+"compareTo"+c2;
				if(c1.id()==c2.id()) assertThat(message,result,is(0));
				else if(c1.id() < c2.id()) assertThat(message,result<0,is(true));
				else if(c1.id() > c2.id()) assertThat(message,result>0,is(true));
			}
		}
	}
}
