package test;
import static org.junit.Assert.*;

import java.util.List;

import kotae.Deck2;
import gacha.Deck1;
import org.junit.Before;
import org.junit.Test;
import card.Card;
import card.Zako;
public class Deck1Test extends CommonDeckTest {
	private Deck1 deck;
	private List<Card> list;
	@Before
	public void setUp() throws Exception {
		deck=new Deck1();
		list = Deck1.getList();
	}
	@Test
	public void testTotal() {
		assertEquals(3.0,deck.total(),Constant.err);
	}
	@Test
	public void testGetCardRate() {
		double[] rate = new double[]{1.0,1.0,1.0};
		assertArrayEquals(rate, toDoubleArray(list,new GetCardRate(deck)), Constant.err);
	}
	@Test
	public void testCalcMap() {
		double[] dist = new double[]{0.0, 0.33333, 0.66667};
		assertArrayEquals(dist, toDoubleArray(deck.calcMap().entrySet(),new GetKey()), Constant.err);
	}
	@Test
	public void testList() {
		assertEquals("[Aka, Ao, Kuro]",list.toString());
	}
	@Test
	public void testGetList() {
		assertEquals("[Aka, Ao, Kuro]",Deck1.getList().toString());
	}
	@Test
	public void testGetListId() {
		int[] ids={0,1,2};
		assertArrayEquals(ids,toIdArray(Deck1.getList()));
	}	
	@Test
	public void testToString() {
		assertEquals("[Aka, Ao, Kuro]",deck.toString());
	}
	@Test
	public void testDraw() {
		Card c = deck.draw();
		assertTrue(c instanceof Zako);
	}
}
