package test;
import static org.junit.Assert.*;

import java.util.List;
import kotae.SuperRare;
import org.junit.Before;
import org.junit.Test;
import player.CardCollection;
import card.SuperRareFactory;
public class SuperRareTest extends CommonCardTest {
	private CardCollection cc1;
	private CardCollection cc2;
	private static final String[] name1 = {"SuperRareAka","SuperRareAo","SuperRareKuro"};
	private static final String[] name2 = {"SuperRareA","SuperRareB","SuperRareC","SuperRareD"};
	private List<SuperRare> list1;
	private List<SuperRare> list2;
	private SuperRareFactory factory1;
	private SuperRareFactory factory2;
	private SuperRareScenario cardTestScenario1;
	private SuperRareScenario cardTestScenario2;
	@Before
	public void setup(){
		cc1 = new CardCollection();
		cc2 = new CardCollection();
		factory1 = new SuperRareFactory(20,name1);
		factory2 = new SuperRareFactory(30,name2);
		list1 = factory1.getList(cc1);
		list2 = factory2.getList(cc2);
		cardTestScenario1 = new SuperRareScenario(list1,cc1);
		cardTestScenario2 = new SuperRareScenario(list2,cc2);
	}
	private static class SuperRareClassTest implements CardTestScenario.Tester<SuperRare>{
		@Override
		public boolean check(SuperRare card) {
			return card instanceof SuperRare;
		}
	}
	@Test
	public void testClass(){
		cardTestScenario1.setTest(new SuperRareClassTest());
		cardTestScenario1.execCheck();
		
		cardTestScenario2.setTest(new SuperRareClassTest());
		cardTestScenario2.execCheck();
	}
	@Test
	public void testVariableRate1(){
		cardTestScenario1.testVariableRate(new int[]{100,100,100});
		cardTestScenario1.drawCard(1);
		cardTestScenario1.testVariableRate(new int[]{1000,100,1000});
		cardTestScenario1.drawCard(1);
		cardTestScenario1.testVariableRate(new int[]{1000,100,1000});
		cardTestScenario1.drawCard(2);
		cardTestScenario1.testVariableRate(new int[]{10000,100,100});
		cardTestScenario1.drawCard(1);
		cardTestScenario1.testVariableRate(new int[]{10000,100,100});
		cardTestScenario1.drawCard(0);
		cardTestScenario1.testVariableRate(new int[]{100,100,100});	
	}
	@Test
	public void testVariableRate2(){
		cardTestScenario2.testVariableRate(new int[]{100,100,100,100});
		cardTestScenario2.drawCard(1);
		cardTestScenario2.testVariableRate(new int[]{100,100,100,100});
		cardTestScenario2.drawCard(1);
		cardTestScenario2.testVariableRate(new int[]{100,100,100,100});
		cardTestScenario2.drawCard(2);
		cardTestScenario2.testVariableRate(new int[]{1000,100,100,1000});
		cardTestScenario2.drawCard(1);
		cardTestScenario2.testVariableRate(new int[]{1000,100,100,1000});
		cardTestScenario2.drawCard(0);
		cardTestScenario2.testVariableRate(new int[]{100,100,100,10000});	
		cardTestScenario2.drawCard(3);
		cardTestScenario2.testVariableRate(new int[]{100,100,100,100});	
	}
	@Test
	public void testMultiplayer(){
		CardCollection cc12 = new CardCollection();
		List<SuperRare> list12 = factory1.getList(cc12);
		SuperRareScenario cardTestScenario12 = new SuperRareScenario(list12,cc12);
		cardTestScenario1.testVariableRate(new int[]{100,100,100});
		cardTestScenario12.testVariableRate(new int[]{100,100,100});
		
		cardTestScenario1.drawCard(0);
		cardTestScenario1.testVariableRate(new int[]{100,1000,1000});
		cardTestScenario12.testVariableRate(new int[]{100,100,100});
		
		cardTestScenario12.drawCard(1);
		cardTestScenario1.testVariableRate(new int[]{100,1000,1000});
		cardTestScenario12.testVariableRate(new int[]{1000,100,1000});
		
		cardTestScenario12.drawCard(2);
		cardTestScenario1.testVariableRate(new int[]{100,1000,1000});
		cardTestScenario12.testVariableRate(new int[]{10000,100,100});
		
		cardTestScenario12.drawCard(0);
		cardTestScenario1.testVariableRate(new int[]{100,1000,1000});
		cardTestScenario12.testVariableRate(new int[]{100,100,100});
		
		cardTestScenario1.drawCard(1);
		cardTestScenario1.testVariableRate(new int[]{100,100,10000});
		cardTestScenario12.testVariableRate(new int[]{100,100,100});
		
		cardTestScenario12.drawCard(0);
		cardTestScenario1.testVariableRate(new int[]{100,100,10000});
		cardTestScenario12.testVariableRate(new int[]{100,100,100});
	}	
	@Test
	public void testToString(){
		assertArrayEquals(name1, toObjectArray(list1,new ToString()));
		assertArrayEquals(name2, toObjectArray(list2,new ToString()));
	}
	@Test
	public void testName(){
		assertArrayEquals(name1, toObjectArray(list1,new Name()));
		assertArrayEquals(name2, toObjectArray(list2,new Name()));
	}
	@Test
	public void testOrder() {
		int[] exp1 = {20,21,22};
		assertArrayEquals(exp1, toIntArray(list1,new Id()));
		int[] exp2 = {30,31,32,33};
		assertArrayEquals(exp2, toIntArray(list2,new Id()));
	}
	@Test
	public void testCompareTo() {
		cardTestScenario1.testCompareTo();
		cardTestScenario2.testCompareTo();
	}
}
