package test;
import static org.junit.Assert.*;
import static org.hamcrest.CoreMatchers.*;
import java.util.Arrays;
import java.util.List;
import org.junit.Before;
import org.junit.Test;
import card.Card;
import card.CardFactory;
import card.Zako;
public class ZakoTest extends CommonCardTest {
	private static final String[] zako1name = {"Aka","Ao","Kuro"};
	private String[] zako2name;
	private List<Card> zako1;
	private List<Card> zako2;
	private CardFactory factory1;
	private CardFactory factory2;
	private CardTestScenario<Card> cardTestScenario1;
	private CardTestScenario<Card> cardTestScenario2;
	@Before
	public void setup(){
		factory1 = new CardFactory(0,zako1name, new Zako());
		zako2name = randomStringArray(Constant.TESTLENGTH);
		factory2 = new CardFactory(10,zako2name, new Zako());
		zako1 = factory1.getList();
		zako2 = factory2.getList();
		cardTestScenario1 = new CardTestScenario<Card>(zako1);
		cardTestScenario2 = new CardTestScenario<Card>(zako2);
	}
	private static class ZakoClassTest implements CardTestScenario.Tester<Card>{
		@Override
		public boolean check(Card card) {
			return card instanceof Zako;
		}
	}
	@Test
	public void testClass(){
		cardTestScenario1.setTest(new ZakoClassTest());
		cardTestScenario1.execCheck();
		
		cardTestScenario2.setTest(new ZakoClassTest());
		cardTestScenario2.execCheck();
	}
	@Test
	public void testRate() {
		int[] exp1 = new int[zako1name.length];
		Arrays.fill(exp1, 1);
		assertArrayEquals(exp1, toIntArray(zako1,new Rate()));
		
		int[] exp2 = new int[zako2name.length];
		Arrays.fill(exp2, 1);
		assertArrayEquals(exp2, toIntArray(zako2,new Rate()));
	}
	@Test
	public void testToString(){
		assertArrayEquals(zako1name, toObjectArray(zako1,new ToString()));
		assertArrayEquals(zako2name, toObjectArray(zako2,new ToString()));
	}
	@Test
	public void testName(){
		assertArrayEquals(zako1name, toObjectArray(zako1,new Name()));
		assertArrayEquals(zako2name, toObjectArray(zako2,new Name()));
	}
	@Test
	public void testOrder() {
		int[] exp1 = CommonCardTest.getIntArray(0,zako1name.length);
		assertArrayEquals(exp1, toIntArray(zako1,new Id()));
		int[] exp2 = CommonCardTest.getIntArray(10,zako2name.length);
		assertArrayEquals(exp2, toIntArray(zako2,new Id()));
	}
	@Test
	public void testCompareTo() {
		cardTestScenario1.testCompareTo();
		cardTestScenario2.testCompareTo();
	}
}
